use std::collections::HashMap;
use std::fs;

pub fn solve() {
    let path = "res/01/input";

    let contents = fs::read_to_string(path).expect("I/O error, wrong path?");

    let result: u32 = contents
        .lines()
        .map(|line| {
            let nums = line
                .chars()
                .filter(|c| c.is_digit(10))
                .collect::<Vec<char>>();
            nums.first().unwrap().to_digit(10).unwrap() * 10
                + nums.last().unwrap().to_digit(10).unwrap()
        })
        .sum();

    println!("Result 1: {}", result);

    let mut txt_nums = HashMap::<&str, u32>::new();
    txt_nums.insert("zero", 0);
    txt_nums.insert("one", 1);
    txt_nums.insert("two", 2);
    txt_nums.insert("three", 3);
    txt_nums.insert("four", 4);
    txt_nums.insert("five", 5);
    txt_nums.insert("six", 6);
    txt_nums.insert("seven", 7);
    txt_nums.insert("eight", 8);
    txt_nums.insert("nine", 9);

    let result: u32 = contents
        .lines()
        .map(|line| {
            let mut nums = Vec::<u32>::new();
            line.chars().enumerate().for_each(|(i, c)| {
                if c.is_digit(10) {
                    nums.push(c.to_digit(10).unwrap());
                    return;
                }
                for (k, v) in txt_nums.clone() {
                    if c == k.chars().next().unwrap()
                        && line.len() - i >= k.len()
                        && (&line[i..i + k.len()]) == k
                    {
                        nums.push(v)
                    }
                }
            });
            nums.first().unwrap() * 10 + nums.last().unwrap()
        })
        .sum();

    println!("Result 2: {}", result);
}
