use regex::Regex;
use std::fs;

pub fn solve() {
    let path = "res/02/input";

    const MAX_R: usize = 12;
    const MAX_G: usize = 13;
    const MAX_B: usize = 14;

    let contents = fs::read_to_string(path).expect("I/O error, wrong path?");
    //let contents = io::BufReader::new(fs::File::open(path).expect("I/O error, wrong path?"));

    let result: usize = contents
        .lines()
        .map(|line| {
            let re = Regex::new(r"(\d+) (\w+)").unwrap();
            let mut col_max = [0, 0, 0];
            for cap in re.captures_iter(line) {
                let number: usize = cap[1].parse().unwrap();
                let color = &cap[2];

                match color {
                    "red" => col_max[0] = std::cmp::max(col_max[0], number),
                    "green" => col_max[1] = std::cmp::max(col_max[1], number),
                    "blue" => col_max[2] = std::cmp::max(col_max[2], number),
                    _ => {}
                }
            }
            col_max
        })
        .enumerate()
        .filter(|(_, [r, g, b])| *r <= MAX_R && *g <= MAX_G && *b <= MAX_B)
        .map(|(i, _)| i + 1)
        .sum();

    println!("Result 1: {}", result);

    let result: usize = contents
        .lines()
        .map(|line| {
            let re = Regex::new(r"(\d+) (\w+)").unwrap();
            let mut col_max = [0, 0, 0];
            for cap in re.captures_iter(line) {
                let number: usize = cap[1].parse().unwrap();
                let color = &cap[2];

                match color {
                    "red" => col_max[0] = std::cmp::max(col_max[0], number),
                    "green" => col_max[1] = std::cmp::max(col_max[1], number),
                    "blue" => col_max[2] = std::cmp::max(col_max[2], number),
                    _ => {}
                }
            }
            col_max
        })
        .map(|[r, g, b]| r * g * b)
        .sum();

    println!("Result 2: {}", result);
}
